<?php

namespace App\Jobs;

use App\Imports\SongDataImport;
use Illuminate\Bus\Queueable;
use Illuminate\Support\Facades\Storage;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Maatwebsite\Excel\Facades\Excel;

//use Illuminate\Foundation\Queue\Queueable;

class ImportSongJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    protected string $filePath;
    public $timeout = 36000;

    /**
     * Create a new job instance.
     */
    public function __construct(string $filePath)
    {
        $this->filePath = $filePath;
    }

    /**
     * Execute the job.
     */
    public function handle(): void
    {
        ini_set('memory_limit', '-1'); // ✅ 增加記憶體限制

        Excel::import(new SongDataImport, $this->filePath);
            // 匯入完成後刪除檔案
        if (Storage::exists($this->filePath)) {
            Storage::delete($this->filePath);
        }
    }
}
